package version10_2_2_1.agnosticMemory;

import java.util.ArrayList;


public class Constructible {

	public ArrayList<Byte[]> pathList;
	public ArrayList<Byte[]>[] proto;

	
	public Constructible(){
		pathList=new ArrayList<Byte[]>();
		proto=new ArrayList[4];
		for (int i=0;i<4;i++){
			proto[i]=new ArrayList<Byte[]>();
		}
		// empty path that correspond to the object itself
		pathList.add(new Byte[0]);
	}
	
	public void addPath(Byte[] p){
		
		int i=0;
		boolean found=false;
		
		////////////////////////////////////////////////////
		// simplification : avoid sequences ^^ and vv
		/*int l1=0;
		while (!found && l1<p.length-1){
			if ((p[l1]==4 && p[l1+1]==4) || (p[l1]==5 && p[l1+1]==5)) found=true;
			l1++;
		}*/
		///////////////////////////////////////////////////
		
		while (!found && i<pathList.size()){
			if (p.length==pathList.get(i).length){
				found=true;
				int l=0;
				while (found && l<p.length){
					if ((int)p[l]!=(int)pathList.get(i)[l]) found=false;
					l++;
				}
			}
			i++;
		}

		if (!found) pathList.add(p);
	}
	
	public void addProto(int id, Byte[] p){
		
		int i=0;
		boolean found=false;
		
		////////////////////////////////////////////////////
		// simplification : avoid sequences ^^ and vv
		/*int l1=0;
		while (!found && l1<p.length-1){
			if ((p[l1]==4 && p[l1+1]==4) || (p[l1]==5 && p[l1+1]==5)) found=true;
			l1++;
		}*/
		///////////////////////////////////////////////////
		
		while (!found && i<proto[id].size()){
			if (p.length==proto[id].get(i).length){
				found=true;
				int l=0;
				while (found && l<p.length){
					if ((int)p[l]!=(int)proto[id].get(i)[l]) found=false;
					l++;
				}
			}
			i++;
		}

		if (!found) proto[id].add(p);
	}
}
