package version10_2_2_1.display;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import version10_2_2_1.platform.Agent;
import version10_2_2_1.Interface.InteractionList;

/**
 * Frame to display signatures of interactions
 * @author simon gay
 */

/* - inherited from EnvPanel :
 *   Agent agent      : pointer to the agent
 */
public class ConstructiblePanel extends EnvPanel implements MouseListener{

	private static final long serialVersionUID = 1L;
	
	private int clic_x=0;
	private int clic_y=0;
	
	private int selected_interaction=1;
	private int selected_interaction2=3;
	private int selected_point=0;
	
	private int selected_constructible=0;
	
	private int selected_map=0;
	
	private int pixel=5;
	
	private int size=InteractionList.size;
	

	public ConstructiblePanel(Agent a){
		super(a);
		addMouseListener(this);
	}
	
	public void setAgent(Agent a){
		agent=a;
	}
	
	public void paintComponent(Graphics g){
		g.setColor(Color.white);
		
		g.fillRect(0, 0, 1050, 900);
		
		
		// draw interaction selector
		for (byte i=0;i<4;i++){
			if (i==selected_interaction) g.setColor(Color.red);
			else g.setColor(Color.black);
			g.fillRect(20, 50+i*20, 10, 10);
		}
		for (byte i=0;i<4;i++){
			if (i==selected_interaction2) g.setColor(Color.red);
			else g.setColor(Color.black);
			g.fillRect(40, 50+i*20, 10, 10);
		}
		
		if (selected_map==0) g.setColor(Color.red);
		else g.setColor(Color.black);
		g.fillRect(20, 250, 10, 10);
		if (selected_map==1) g.setColor(Color.red);
		else g.setColor(Color.black);
		g.fillRect(20, 270, 10, 10);
		
		// draw constructible properties
		int index=0;
		g.setColor(Color.black);
		g.drawString("movable object "+selected_interaction+" : ", 100+ (int)(index/50)*480, 15+15*(index%50));
		index++;
		if (selected_constructible==index){
			g.setColor(Color.red);
		}
		else g.setColor(Color.black);
		g.fillRect(85+(int)(index/50)*480, 6+15*(index%50),10,10);
		
		for (int i=0;i<agent.signatureList.workMemory[selected_interaction].constructible.pathList.size();i++){
			String path="{";
			for (int l=agent.signatureList.workMemory[selected_interaction].constructible.pathList.get(i).length-1;l>=0;l--){
				path+=agent.signatureList.workMemory[selected_interaction].constructible.pathList.get(i)[l]+", ";
			}
			path+="}";
			
			g.setColor(Color.black);
			g.drawString(path, 100+ (int)(index/50)*480, 15+15*(index%50));
			
			index++;
		}
		index++;
		g.setColor(Color.black);
		for (int k=0;k<4;k++){
			if (agent.signatureList.workMemory[selected_interaction].constructible.proto[k].size()>0){
				g.drawString("proto-object "+k+" : ", 100+ (int)(index/50)*480, 15+15*(index%50));
				
				for (int i=0;i<agent.signatureList.workMemory[selected_interaction].constructible.proto[k].size();i++){
					String path="[";
					for (int l=agent.signatureList.workMemory[selected_interaction].constructible.proto[k].get(i).length-1;l>=0;l--){
						path+=agent.signatureList.workMemory[selected_interaction].constructible.proto[k].get(i)[l]+", ";
					}
					path+="]";
	
					g.drawString(path, 200+ (int)(index/50)*480, 15+15*(index%50));
					
					index++;
				}
				index++;
			}
		}
	}
	
	
	///////////////////////////////////////////////////////////////////////////
	public void mouseClicked(MouseEvent e) {

		clic_x=e.getX();
		clic_y=e.getY();
	
		
		// selection of path
		if (clic_x>=85){
			int id_x=(clic_x-85)/480;
			int id_y=(clic_y-6)/15;
			if (clic_x>=85+id_x*480 && clic_x<=95+id_x*480 && clic_y>=6+15*id_y && clic_y<=16+15*id_y){
				selected_constructible=id_x*50+id_y;
				//change=true;
			}
		}
		
		for (short j=0;j<4;j++){
			if (clic_x>=18 && clic_x<32 && clic_y>=48+20*j && clic_y<62+20*j){
				selected_interaction=j;
			}
		}
		
		for (short j=0;j<4;j++){
			if (clic_x>=38 && clic_x<52 && clic_y>=48+20*j && clic_y<62+20*j){
				selected_interaction2=j;
			}
		}
		
		if (clic_x>=18 && clic_x<32 && clic_y>=248 && clic_y<262){
			selected_map=0;
		}
		if (clic_x>=18 && clic_x<32 && clic_y>=268 && clic_y<282){
			selected_map=1;
		}
		
		int offset=0;
		for (int n=0;n<6;n++){
			offset=n*130;
			for (int i=0;i<size;i++){
				for (int j=0;j<size;j++){
					
					if (clic_x>=50+i*pixel && clic_x<50+(i+1)*pixel && clic_y>=(140-j*pixel)+offset && clic_y<(140-(j-1)*pixel)+offset){
						selected_point=i*size*4+j*4+n*size*size*4  ;
					}
					if (clic_x>=180+i*pixel && clic_x<180+(i+1)*pixel && clic_y>=(140-j*pixel)+offset && clic_y<(140-(j-1)*pixel)+offset){
						selected_point=i*size*4+j*4+n*size*size*4+1;
					}
					if (clic_x>=310+i*pixel && clic_x<310+(i+1)*pixel && clic_y>=(140-j*pixel)+offset && clic_y<(140-(j-1)*pixel)+offset){
						selected_point=i*size*4+j*4+n*size*size*4+2;
					}
					if (clic_x>=440+i*pixel && clic_x<440+(i+1)*pixel && clic_y>=(140-j*pixel)+offset && clic_y<(140-(j-1)*pixel)+offset){
						selected_point=i*size*4+j*4+n*size*size*4+3;
					}
				}
			}
		}
	}

	@Override
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}

}