package version10_2_2_1.display;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import version10_2_2_1.platform.Agent;
import version10_2_2_1.Interface.InteractionList;

/**
 * Frame to display signatures of interactions
 * @author simon gay
 */

/* - inherited from EnvPanel :
 *   Agent agent      : pointer to the agent
 */
public class ContextPanel extends EnvPanel implements MouseListener{

	private static final long serialVersionUID = 1L;

	private short clic_x=0;
	private short clic_y=0;
	
	private byte pixel=4;
	
	private byte selected_color=0;
	
	private byte counterSelector=0;
	
	private int size=InteractionList.size;

	public ContextPanel(Agent a){
		super(a);
		addMouseListener(this);
	}
	
	public void setAgent(Agent a){
		agent=a;
	}
	
	public void paintComponent(Graphics g){
		g.setColor(Color.white);
		
		g.fillRect(0, 0, 1300, 900);
		
		//////////////////////////////////////////////////////////////
		// draw interactional context

		// dynamic features
		for (byte n=0;n<6;n++){
			for (short i=0;i<size;i++){
				for (short j=0;j<size;j++){
					g.setColor(new Color(agent.environmentContext.enactedEnsembles[0][n*size*size*4+i*size*4+j*4+ 2],
										 agent.environmentContext.enactedEnsembles[0][n*size*size*4+i*size*4+j*4   ],
							 			 agent.environmentContext.enactedEnsembles[0][n*size*size*4+i*size*4+j*4+ 3] ));
					//g.setColor(agent.topView.map[i][j]);
					g.fillRect(40+i*pixel+ n*27*pixel, 50+(17-j)*pixel , pixel, pixel);
					
					g.setColor(new Color(agent.environmentContext.enactedEnsembles[0][n*size*size*4+i*size*4+j*4+1],
							 			 agent.environmentContext.enactedEnsembles[0][n*size*size*4+i*size*4+j*4+1],
							 			 agent.environmentContext.enactedEnsembles[0][n*size*size*4+i*size*4+j*4+1] ));
					//g.setColor(agent.topView.map[i][j]);
					g.fillRect(40+i*pixel+ n*27*pixel, 160+(17-j)*pixel , pixel, pixel);
				}
			}
		}
		
		// primitive interactions
		for (byte i=0;i<6;i++){
			g.setColor(new Color(1-(agent.environmentContext.enactedEnsembles[0][InteractionList.nbDF+i]/2+0.5f),
								    agent.environmentContext.enactedEnsembles[0][InteractionList.nbDF+i]/2+0.5f,0));

			g.fillRect(50+i*20, 330, 10, 10);
		}
		
		// color selector
		g.setColor(Color.green);
		g.fillRect(200, 250, 10, 10);
		g.setColor(Color.blue);
		g.fillRect(220, 250, 10, 10);
		g.setColor(Color.red);
		g.fillRect(240, 250, 10, 10);
		
		
		
		///////////////////////////////////////////////////////////////////////////////
		// draw counters
		
		// draw selector
		for (byte i=0;i<5;i++){
			if (counterSelector==i) g.setColor(Color.red);
			else g.setColor(Color.black);
			
			g.fillRect(20,225+i*20,10,10);
		}

		// dynamic features
		/*for (byte n=0;n<6;n++){
			for (short i=0;i<size;i++){
				for (short j=0;j<size;j++){
					g.setColor(new Color(255-agent.environmentContext.counter[counterSelector][n*size*size*4+i*size*4+j*4+2],
										 255-agent.environmentContext.counter[counterSelector][n*size*size*4+i*size*4+j*4  ],
										 255-agent.environmentContext.counter[counterSelector][n*size*size*4+i*size*4+j*4+3] ));
					
					g.fillRect(40+i*pixel+ n*27*pixel, 300+(17-j)*pixel , pixel, pixel);
					
					g.setColor(new Color(255-agent.environmentContext.counter[counterSelector][n*size*size*4+i*size*4+j*4+1],
							 			 255-agent.environmentContext.counter[counterSelector][n*size*size*4+i*size*4+j*4+1],
							 			 255-agent.environmentContext.counter[counterSelector][n*size*size*4+i*size*4+j*4+1] ));
		
					g.fillRect(40+i*pixel+ n*27*pixel, 410+(17-j)*pixel , pixel, pixel);
				}
			}
		}
		
		// primitive interactions
		for (byte i=0;i<6;i++){
			g.setColor(new Color(255-agent.environmentContext.counter[counterSelector][InteractionList.nbDF+i],
							     255-agent.environmentContext.counter[counterSelector][InteractionList.nbDF+i],
							     255-agent.environmentContext.counter[counterSelector][InteractionList.nbDF+i]));

			g.fillRect(50+i*20, 510, 10, 10);
		}*/
	}
	
	
	///////////////////////////////////////////////////////////////////////////
	public void mouseClicked(MouseEvent e) {

		clic_x=(short) e.getX();
		clic_y=(short) e.getY();

		for (byte c=0;c<3;c++){
			if (clic_x>=200+20*c && clic_x<220+10*c && clic_y>=250 && clic_y<260)
				selected_color=c;
		}
		
		
		for (byte l=0;l<6;l++){
			for (byte n=0;n<6;n++){
				for (short i=0;i<size;i++){
					for (short j=0;j<size;j++){
						if (clic_x>=10+i*pixel+34*pixel*l     && clic_x<10+i*pixel+34*pixel*l+pixel
								 && clic_y>=(17-j)*pixel + n*17*pixel && clic_y<(17-j)*pixel + n*17*pixel+pixel){
							if (l==4){
								if (selected_color==0) agent.observer.setSelectedNode(n*size*size*4+i*size*4 + j*4 + 2);
								if (selected_color==1) agent.observer.setSelectedNode(n*size*size*4+i*size*4 + j*4    );
								if (selected_color==2) agent.observer.setSelectedNode(n*size*size*4+i*size*4 + j*4 + 1);
							}
							else{
								agent.observer.setSelectedNode(i*size + j + n*size*size);
							}
						}
					}
				}
				
			}
		}
		
		// primitive interactions
		for (byte i=0;i<6;i++){
			
			if (clic_x>=20+i*20 && clic_x<=30+i*20 && clic_y>=430 && clic_y<=440){
				agent.observer.setSelectedNode(InteractionList.nbDF+i);
			}
		}
		
		// counter selector
		for (byte i=0;i<6;i++){
			if (clic_x>=20 && clic_x<=30 && clic_y>=225+i*20 && clic_y<=235+i*20)
				counterSelector=i;
		}
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}
