package version10_2_2_1.display;

import java.awt.Color;
import java.awt.Graphics;

import version10_2_2_1.platform.Agent;
import version10_2_2_1.platform.Observer;

/**
 * Display information about signatures
 * @author simon gay
 */

/* - inherited from EnvPanel :
 *   Agent agent      : pointer to the agent
 */
public class PathDataPanel extends EnvPanel{

	private static final long serialVersionUID = 1L;
	
	private static final int h=750;
	private static final int w=Observer.nbStep;
	
	private float height;
	
	public PathDataPanel(Agent a){
		super(a);
		
		int nb=10000;
		height=(float)h/(float)nb;
	}
	
	
	public void paintComponent(Graphics g){
		g.setColor(Color.white);
		
		g.fillRect(0, 0, w+50, h+50);
		
		g.setColor(Color.black);
		g.drawLine(0, h, w, h);
		
		g.setColor(Color.lightGray);
		int n=1;
		while(n*height*50<h){
			g.drawLine(0, h-(int)(n*height*50), w, h-(int)(n*height*50) );
			n++;
		}

		//for (int l=0;l<10;l++){
		int l=0;
			//g.setColor(new Color(20*l, 200-20*l,0));
			
			for (int i=0;i<w;i++){
			
				if (i!=agent.observer.indexPattern){
				
					// display the number of interaction
					
					//g.drawLine((w-agent.observer.indexPattern+i)%w   , (int)(h-y2;=(int)(h-agent.observer.timelineNbPattern[((w-1)+i-1)%(w-1)][l]*height);*height),
					//		   (w-agent.observer.indexPattern+(i-1))%w,(int)(h-agent.observer.timelineNbPattern[((w-1)+i-1)%(w-1)][l]*height));
					
					int y1;
					int y2;
					
					/*if (agent.observer.timelineNbPattern[((w-1)+i  )%(w-1)][l]==0) y1=h;
					else y1=(int)(h-(float)agent.observer.timelineNbUnreliable[((w-1)+i  )%(w-1)][l]*5000*height/(float)agent.observer.timelineNbPattern[((w-1)+i  )%(w-1)][l]);
					
					if (agent.observer.timelineNbPattern[((w-1)+i-1)%(w-1)][l]==0) y2=h;
					else y2=(int)(h-(float)agent.observer.timelineNbUnreliable[((w-1)+i-1)%(w-1)][l]*5000*height/(float)agent.observer.timelineNbPattern[((w-1)+i-1)%(w-1)][l]);
					
					g.drawLine((w-agent.observer.indexPattern+i)%w   , y1,
							   (w-agent.observer.indexPattern+(i-1))%w,y2);*/
					
					// nb of unreliable
					//y1=(int)(h-agent.observer.timelineNbUnreliable[((w-1)+i  )%(w-1)]*height);
					//y2=(int)(h-agent.observer.timelineNbUnreliable[((w-1)+i-1)%(w-1)]*height);
					
					//g.setColor(Color.blue);
					//g.drawLine((w-agent.observer.indexPattern+i)%w   , y1,
					//		   (w-agent.observer.indexPattern+(i-1))%w,y2);
					
					// nb of paths
					y1=(int)(h-agent.observer.timelineNbPattern[((w-1)+i  )%(w-1)]*height);
					y2=(int)(h-agent.observer.timelineNbPattern[((w-1)+i-1)%(w-1)]*height);
					
					g.setColor(Color.green);
					g.drawLine((w-agent.observer.indexPattern+i)%w   , y1,
							   (w-agent.observer.indexPattern+(i-1))%w,y2);
					
					// nb of correct paths
					y1=(int)(h-agent.observer.timelineNbCorrect[((w-1)+i  )%(w-1)]*height);
					y2=(int)(h-agent.observer.timelineNbCorrect[((w-1)+i-1)%(w-1)]*height);
					
					g.setColor(Color.red);
					g.drawLine((w-agent.observer.indexPattern+i)%w   , y1,
							   (w-agent.observer.indexPattern+(i-1))%w,y2);
				}

			}
		//}
	}
	
}
