package version10_2_2_1.display;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import version10_2_2_1.platform.Agent;
import version10_2_2_1.Interface.InteractionList;
import version10_2_2_1.agnosticMemory.Signature;

/**
 * Frame to display signatures of interactions
 * @author simon gay
 */

/* - inherited from EnvPanel :
 *   Agent agent      : pointer to the agent
 */
public class SignaturePanel extends EnvPanel implements MouseListener{

	private static final long serialVersionUID = 1L;
	
	private int clic_x=0;
	private int clic_y=0;
	
	private int selected_color=0;
	//private int selected_context=1;
	private boolean secondary=true;
	
	private int pixel=5;
	
	private int size=InteractionList.size;
	
	private boolean threshold=false;
	
	public SignaturePanel(Agent a){
		super(a);
		addMouseListener(this);
	}
	
	public void setAgent(Agent a){
		agent=a;
	}
	
	public void paintComponent(Graphics g){
		g.setColor(Color.white);
		
		g.fillRect(0, 0, 1050, 900);
		
		//////////////////////////////////////////////////////////////
		// draw interactional context
		
		// dynamic features
		int offset=0;
		for (int n=0;n<6;n++){
			offset=n*130;
			for (int i=0;i<size;i++){
				for (int j=0;j<size;j++){
					
					/*g.setColor(new Color(agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+2],
										 agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4  ],
										 agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+3] ));
					
					g.fillRect(20+i*pixel, (140-j*pixel)+offset, pixel, pixel);
					
					g.setColor(new Color(agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+1],
										 agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+1],
										 agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+1] ));
		
					g.fillRect(150+i*pixel, (140-j*pixel)+offset, pixel, pixel);
					*/
					
					g.setColor(new Color(agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+2]+agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+3],
							 agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4  ]+agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+3],
							 agent.environmentContext.enactedEnsembles[0][i*size*4+j*4+n*size*size*4+1] ));
		
					g.fillRect(20+i*pixel, (140-j*pixel)+offset, pixel, pixel);
					
					if (i*size*4+j*4+n*size*size*4+selected_color==agent.observer.getSelectedNode()){
						g.setColor(Color.white);
						if (selected_color!=1) g.drawRect(20+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						else  g.drawRect(150+i*pixel, (140-j*pixel)+offset, pixel, pixel);
					}
					
				}
			}
			
		}
		
		// primitive interactions
		for (int i=0;i<6;i++){
			g.setColor(new Color(1-(agent.environmentContext.enactedEnsembles[0][InteractionList.nbDF+i]/2+0.5f),
								    agent.environmentContext.enactedEnsembles[0][InteractionList.nbDF+i]/2+0.5f,0));

			g.fillRect(20+i*20, 800, 10, 10);
			
			if (InteractionList.nbDF+i==agent.observer.getSelectedNode()){
				g.setColor(Color.black);
				g.drawRect(19+i*20, 799, 11, 11);
			}
		}
		
		// draw agent position
		g.setColor(Color.white);
		for (int n=0;n<6;n++){
			offset=n*130;
			g.drawOval(21+(size/2)*pixel, (141-(size/2)*pixel)+offset, pixel-2, pixel-2);
			g.drawOval(151+(size/2)*pixel, (141-(size/2)*pixel)+offset, pixel-2, pixel-2);
		}
		
		// color selection
		g.setColor(Color.green);
		g.fillRect(280, 30, 10, 10);
		g.setColor(Color.blue);
		g.fillRect(280, 50, 10, 10);
		g.setColor(Color.red);
		g.fillRect(280, 70, 10, 10);
		
		g.setColor(Color.cyan);
		g.fillRect(280, 90, 10, 10);
		
		g.setColor(Color.black);
		g.drawRect(259, 29+20*selected_color, 11, 11);
		
		if (threshold) g.setColor(Color.red);
		else g.setColor(Color.black);
		g.fillRect(260, 120, 10, 10);
		

		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		// predictions
		offset=0;
		for (int n=0;n<6;n++){
			offset=n*130;
			for (int i=0;i<size;i++){
				for (int j=0;j<size;j++){

					g.setColor(new Color(Math.max(0,agent.signatureList.get(i*size*4+j*4+n*size*size*4+2).getPrediction()),
										 Math.max(0,agent.signatureList.get(i*size*4+j*4+n*size*size*4  ).getPrediction()),
										 Math.max(0,agent.signatureList.get(i*size*4+j*4+n*size*size*4+3).getPrediction()) ));
					g.fillRect(300+i*pixel, (140-j*pixel)+offset, pixel, pixel);

					g.setColor(new Color(Math.max(0,agent.signatureList.get(i*size*4+j*4+n*size*size*4+1).getPrediction()),
										 Math.max(0,agent.signatureList.get(i*size*4+j*4+n*size*size*4+1).getPrediction()),
										 Math.max(0,agent.signatureList.get(i*size*4+j*4+n*size*size*4+1).getPrediction()) ));
					g.fillRect(440+i*pixel, (140-j*pixel)+offset, pixel, pixel);
				}
			}
		}
		
		// primitive interactions
		for (int i=0;i<6;i++){
			g.setColor(new Color(1-(agent.signatureList.get(InteractionList.nbDF+i).getPrediction()/2+0.5f),
								    agent.signatureList.get(InteractionList.nbDF+i).getPrediction()/2+0.5f,0));
			g.fillRect(300+i*20, 800, 10, 10);
		}
		
		
		
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		// selector
		if (secondary) g.setColor(Color.red);
		else g.setColor(Color.black);
		g.fillRect(610, 300, 20, 20);
				
		// contexts
		if (agent.observer.getSelectedNode()!=-1){
			

			// dynamic features
			offset=0;
			Signature sig=agent.signatureList.get(agent.observer.getSelectedNode());
			int[] img;
			
			g.setColor(Color.black);
			g.drawString(sig.nb_s_t+"/"+sig.nb_test_t, 650, 370);
			if (sig.activated_t) g.drawString("activated", 700, 370);
			if (sig.inhibition_t) g.drawString("inhibited", 700, 380);
			g.drawString(sig.context_t.size()+"", 650, 380);
			

			int nb=0;
			
			for (short c=0;c<sig.context_t.size();c++){
				
				img=sig.context_t.get(c).getImage();
				
				// remove elements that also depend of the associated primary interaction
				/*if (!secondary && agent.observer.getSelectedNode()<InteractionList.nbDF){
					for (short i=0;i<InteractionList.length;i++){
						if (img[i]>0 && agent.signatureList.get(InteractionList.nbDF+sig.interaction.getIndex()).signatureMap[i]) img[i]=0; 
					}
				}*/
				
				for (int n=0;n<6;n++){
					offset=n*60;
					
					for (int i=0;i<size;i++){
						for (int j=0;j<size;j++){
							
							/*g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+2],
												 img[i*size*4+j*4+n*size*size*4  ],
												 img[i*size*4+j*4+n*size*size*4+3] ));
							
							g.fillRect(800+i*2 +nb*120, (50-j*2)+offset, 2, 2);
							
							g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+1],
												 img[i*size*4+j*4+n*size*size*4+1],
												 img[i*size*4+j*4+n*size*size*4+1] ));
				
							g.fillRect(854+i*2+nb*120, (50-j*2)+offset, 2, 2);*/
							
							g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+2]+img[i*size*4+j*4+n*size*size*4+3],
									 			 img[i*size*4+j*4+n*size*size*4  ]+img[i*size*4+j*4+n*size*size*4+3],
									 			 img[i*size*4+j*4+n*size*size*4+1] ));
				
							g.fillRect(800+i*2 +nb*70, (50-j*2)+offset, 2, 2);
						}
					}
				}
			
				// primitive interactions
				for (int i=0;i<6;i++){
					if (sig.context_t.get(c).index_primary-InteractionList.nbDF==i) g.setColor(Color.green);
					else g.setColor(Color.black);
					g.fillRect(800+i*10+70*nb, 355, 5, 5);
				}
				
				g.setColor(Color.black);
				g.drawString(sig.context_t.get(c).nb_s+"/"+sig.context_t.get(c).nb_test, 800+70*nb, 370);
				if (sig.context_t.get(c).activated) g.drawString("activated", 850+70*nb, 370);
				if (sig.context_t.get(c).inhibition) g.drawString("inhibited", 850+70*nb, 380);
				g.drawString(sig.context_t.get(c).included.size()+"", 800+70*nb, 380);
				g.drawString(sig.context_t.get(c).failure+"", 800+70*nb, 390);
				
				nb++;
				
				// draw included contexts
				for (short c2=0;c2<sig.context_t.get(c).included.size();c2++){
					
					img=sig.context_t.get(c).included.get(c2).getImage();
					
					for (int n=0;n<6;n++){
						offset=n*60;
						
						for (int i=0;i<size;i++){
							for (int j=0;j<size;j++){
								
								/*g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+2],
													 img[i*size*4+j*4+n*size*size*4  ],
													 img[i*size*4+j*4+n*size*size*4+3] ));
								
								g.fillRect(800+i*2 +nb*120, 10+(50-j*2)+offset, 2, 2);
								
								g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+1],
													 img[i*size*4+j*4+n*size*size*4+1],
													 img[i*size*4+j*4+n*size*size*4+1] ));
					
								g.fillRect(854+i*2+nb*120, 10+(50-j*2)+offset, 2, 2);*/
								
								g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+2]+img[i*size*4+j*4+n*size*size*4+3],
										 			 img[i*size*4+j*4+n*size*size*4  ]+img[i*size*4+j*4+n*size*size*4+3],
										 			 img[i*size*4+j*4+n*size*size*4+1] ));
					
								g.fillRect(800+i*2 +nb*70, 10+(50-j*2)+offset, 2, 2);
							}
						}
					}
				
					// primitive interactions
					for (int i=0;i<6;i++){
						if (sig.context_t.get(c).index_primary-InteractionList.nbDF==i) g.setColor(Color.green);
						else g.setColor(Color.black);
						g.fillRect(800+i*10+70*nb, 10+355, 5, 5);
					}
					
					g.setColor(Color.black);
					g.drawString(sig.context_t.get(c).included.get(c2).nb_s+"/"+sig.context_t.get(c).included.get(c2).nb_test, 800+70*nb, 10+370);
					if (sig.context_t.get(c).included.get(c2).activated) g.drawString("activated", 850+70*nb, 10+370);
					if (sig.context_t.get(c).included.get(c2).inhibition) g.drawString("inhibited", 850+70*nb, 10+380);
					g.drawString(sig.context_t.get(c).included.get(c2).included.size()+"", 800+70*nb, 10+380);
					g.drawString(sig.context_t.get(c).included.get(c2).failure+"", 800+70*nb, 10+390);
					
					nb++;
				}
			}
			
			g.setColor(Color.black);
			g.drawString(sig.nb_s_f+"/"+sig.nb_test_f, 650, 770);
			if (sig.activated_f) g.drawString("activated", 700, 770);
			if (sig.inhibition_f) g.drawString("inhibited", 700, 780);
			g.drawString(sig.context_f.size()+"", 650, 780);
			

			nb=0;
			
			for (short c=0;c<sig.context_f.size();c++){
				
				img=sig.context_f.get(c).getImage();
				
				// remove elements that also depend of the associated primary interaction
				/*if (!secondary && agent.observer.getSelectedNode()<InteractionList.nbDF){
					for (short i=0;i<InteractionList.length;i++){
						if (img[i]>0 && agent.signatureList.get(InteractionList.nbDF+sig.interaction.getIndex()).signatureMap[i]) img[i]=0; 
					}
				}*/

				for (int n=0;n<6;n++){
					offset=n*60;
					
					for (int i=0;i<size;i++){
						for (int j=0;j<size;j++){
							
							/*g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+2],
												 img[i*size*4+j*4+n*size*size*4  ],
												 img[i*size*4+j*4+n*size*size*4+3] ));
							
							g.fillRect(800+i*2 +nb*120, (450-j*2)+offset, 2, 2);
							
							g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+1],
												 img[i*size*4+j*4+n*size*size*4+1],
												 img[i*size*4+j*4+n*size*size*4+1] ));
				
							g.fillRect(854+i*2+nb*120, (450-j*2)+offset, 2, 2);*/
							
							g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+2]+img[i*size*4+j*4+n*size*size*4+3],
									 			 img[i*size*4+j*4+n*size*size*4  ]+img[i*size*4+j*4+n*size*size*4+3],
									 			 img[i*size*4+j*4+n*size*size*4+1] ));
				
							g.fillRect(800+i*2 +nb*70, (450-j*2)+offset, 2, 2);
						}
					}
				}
			
				// primitive interactions
				for (int i=0;i<6;i++){
					if (sig.context_f.get(c).index_primary-InteractionList.nbDF==i) g.setColor(Color.green);
					else g.setColor(Color.black);
					g.fillRect(800+i*10+70*nb, 755, 5, 5);
				}
				
				g.setColor(Color.black);
				g.drawString(sig.context_f.get(c).nb_s+"/"+sig.context_f.get(c).nb_test, 800+70*nb, 770);
				if (sig.context_f.get(c).activated) g.drawString("activated", 850+70*nb, 770);
				if (sig.context_f.get(c).inhibition) g.drawString("inhibited", 850+70*nb, 780);
				g.drawString(sig.context_f.get(c).included.size()+"", 800+70*nb, 780);
				g.drawString(sig.context_f.get(c).failure+"", 800+70*nb, 790);
				
				nb++;
				
				// draw included contexts
				for (short c2=0;c2<sig.context_f.get(c).included.size();c2++){
					
					img=sig.context_f.get(c).included.get(c2).getImage();
					
					for (int n=0;n<6;n++){
						offset=n*60;
						
						for (int i=0;i<size;i++){
							for (int j=0;j<size;j++){
								
								/*g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+2],
													 img[i*size*4+j*4+n*size*size*4  ],
													 img[i*size*4+j*4+n*size*size*4+3] ));
								
								g.fillRect(800+i*2 +nb*120, 10+(450-j*2)+offset, 2, 2);
								
								g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+1],
													 img[i*size*4+j*4+n*size*size*4+1],
													 img[i*size*4+j*4+n*size*size*4+1] ));
					
								g.fillRect(854+i*2+nb*120, 10+(450-j*2)+offset, 2, 2);*/
								
								g.setColor(new Color(img[i*size*4+j*4+n*size*size*4+2]+img[i*size*4+j*4+n*size*size*4+3],
										 			 img[i*size*4+j*4+n*size*size*4  ]+img[i*size*4+j*4+n*size*size*4+3],
										 			 img[i*size*4+j*4+n*size*size*4+1] ));
					
								g.fillRect(800+i*2 +nb*70, 10+(450-j*2)+offset, 2, 2);
							}
						}
					}
				
					// primitive interactions
					for (int i=0;i<6;i++){
						if (sig.context_f.get(c).index_primary-InteractionList.nbDF==i) g.setColor(Color.green);
						else g.setColor(Color.black);
						g.fillRect(800+i*10+70*nb, 10+755, 5, 5);
					}
					
					g.setColor(Color.black);
					g.drawString(sig.context_f.get(c).included.get(c2).nb_s+"/"+sig.context_f.get(c).included.get(c2).nb_test, 800+70*nb, 10+770);
					if (sig.context_f.get(c).included.get(c2).activated) g.drawString("activated", 850+70*nb, 10+770);
					if (sig.context_f.get(c).included.get(c2).inhibition) g.drawString("inhibited", 850+70*nb, 10+780);
					g.drawString(sig.context_f.get(c).included.get(c2).included.size()+"", 800+70*nb, 10+780);
					g.drawString(sig.context_f.get(c).included.get(c2).failure+"", 800+70*nb, 10+790);
					
					nb++;
				}
			}
		}
	}
	
	
	
	///////////////////////////////////////////////////////////////////////////
	public void mouseClicked(MouseEvent e) {

		clic_x=e.getX();
		clic_y=e.getY();
		
		float dmin=1000;
		float d=10;
		
		int offset=0;
		for (int n=0;n<6;n++){
			offset=n*130;
			for (int i=0;i<InteractionList.size;i++){
				for (int j=0;j<InteractionList.size;j++){
					d=(clic_x-(20+i*pixel))*(clic_x-(20+i*pixel) ) + (clic_y - (140-j*pixel+offset))*(clic_y - (140-j*pixel+offset));
					if (d<dmin){
						dmin=d;
						agent.observer.setSelectedNode(i*size*4 + j*4 + n*size*size*4 + selected_color);
					}
				}
			}
		}
		
		for (int n=0;n<6;n++){
			offset=n*130;
			for (int i=0;i<InteractionList.size;i++){
				for (int j=0;j<InteractionList.size;j++){
					d=(clic_x-(150+i*pixel))*(clic_x-(150+i*pixel) ) + (clic_y - (140-j*pixel+offset))*(clic_y - (140-j*pixel+offset));
					if (d<dmin){
						dmin=d;
						selected_color=1;
						agent.observer.setSelectedNode(i*size*4 + j*4 + n*size*size*4 + selected_color);
					}
				}
			}
		}

		for (int i=0;i<6;i++){
			d=(clic_x-(25+i*20))*(clic_x-(25+i*20) ) + (clic_y - 805)*(clic_y - 805);
			if (d<dmin){
				dmin=d;
				agent.observer.setSelectedNode(InteractionList.nbDF + i);
			}
		}
		
		
		
		for (int i=0;i<4;i++){
			d=(clic_x-(285))*(clic_x-(285) ) + (clic_y - (35+20*i))*(clic_y - (35+20*i));
			if (d<dmin){
				dmin=d;
				selected_color=i;
			}
		}
		
		d=(clic_x-(265))*(clic_x-(265) ) + (clic_y - (125))*(clic_y - (125));
		if (d<dmin){
			threshold=!threshold;
		}

		System.out.println("+++++ "+agent.observer.getSelectedNode()+" : "
				+agent.signatureList.get(agent.observer.getSelectedNode()).getPrediction()+" ; ");
		
		if (clic_x>=610 && clic_x<=620 && clic_y>=300 && clic_y<=320) secondary=!secondary;
	}

	@Override
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}

}