package version10_2_2_1.display;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import version10_2_2_1.platform.Agent;
import version10_2_2_1.Interface.InteractionList;

/**
 * Frame to display signatures of interactions
 * @author simon gay
 */

/* - inherited from EnvPanel :
 *   Agent agent      : pointer to the agent
 */
public class WorkMemPanel extends EnvPanel implements MouseListener{

	private static final long serialVersionUID = 1L;
	
	private int clic_x=0;
	private int clic_y=0;
	
	private int selected_interaction=1;
	private int selected_point=0;
	
	private int selected_map=0;
	
	private int pixel=5;
	
	private int size=InteractionList.size;
	

	public WorkMemPanel(Agent a){
		super(a);
		addMouseListener(this);
	}
	
	public void setAgent(Agent a){
		agent=a;
	}
	
	public void paintComponent(Graphics g){
		g.setColor(Color.white);
		
		g.fillRect(0, 0, 1050, 900);
		
		
		// draw interaction selector
		for (byte i=0;i<4;i++){
			if (i==selected_interaction) g.setColor(Color.red);
			else g.setColor(Color.black);
			g.fillRect(20, 50+i*20, 10, 10);
		}
		
		for (byte i=0;i<3;i++){
			if (i==selected_map) g.setColor(Color.red);
			else g.setColor(Color.black);
			g.fillRect(20, 250+i*20, 10, 10);
		}
		
		//////////////////////////////////////////////////////////////
		// draw memory
		
		int offset=0;
		if (selected_map==0){

			for (int n=0;n<6;n++){
				offset=n*130;
				for (int i=0;i<size;i++){
					for (int j=0;j<size;j++){
						
						if (agent.signatureList.workMemory[selected_interaction].memory[i*size*4+j*4+n*size*size*4  ].isActive()) g.setColor(Color.green);
						else g.setColor(Color.black);
						g.fillRect(50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4  ){
							g.setColor(Color.white);
							g.drawRect(50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						}
						
						if (agent.signatureList.workMemory[selected_interaction].memory[i*size*4+j*4+n*size*size*4+1].isActive()) g.setColor(Color.blue);
						else g.setColor(Color.black);
						g.fillRect(130+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4+1){
							g.setColor(Color.white);
							g.drawRect(130+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						}
						
						if (agent.signatureList.workMemory[selected_interaction].memory[i*size*4+j*4+n*size*size*4+2].isActive()) g.setColor(Color.red);
						else g.setColor(Color.black);
						g.fillRect(260+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4+2){
							g.setColor(Color.white);
							g.drawRect(260+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						}
						
						if (agent.signatureList.workMemory[selected_interaction].memory[i*size*4+j*4+n*size*size*4+3].isActive()) g.setColor(new Color(125,125,0));
						else g.setColor(Color.black);
						g.fillRect(390+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4+3){
							g.setColor(Color.white);
							g.drawRect(390+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						}
					}
				}
			}
			
			// draw paths
			g.setColor(Color.black);
			for (int i=0;i<agent.signatureList.workMemory[selected_interaction].memory[selected_point].size();i++){
				String path="[";
				for (int l=agent.signatureList.workMemory[selected_interaction].memory[selected_point].pathList.get(i).length-1;l>=0;l--){
					path+=agent.signatureList.workMemory[selected_interaction].memory[selected_point].pathList.get(i)[l]+", ";
				}
				path+="] ; ";
				for (int l=agent.signatureList.workMemory[selected_interaction].memory[selected_point].originList.get(i).length-1;l>=0;l--){
					path+=agent.signatureList.workMemory[selected_interaction].memory[selected_point].originList.get(i)[l]+", ";
				}
				g.drawString(path, 600, 20+15*i);
			}
		}
		else{
			for (int n=0;n<6;n++){
				offset=n*130;
				for (int i=0;i<size;i++){
					for (int j=0;j<size;j++){
						
						if (agent.signatureList.workMemory[selected_interaction].reference[selected_map-1][i*size*4+j*4+n*size*size*4].originList.size()>0) g.setColor(Color.green);
						else g.setColor(Color.black);
						g.fillRect(50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4  ){
							g.setColor(Color.white);
							g.drawRect(50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						}
						
						if (agent.signatureList.workMemory[selected_interaction].reference[selected_map-1][i*size*4+j*4+n*size*size*4+1].originList.size()>0) g.setColor(Color.blue);
						else g.setColor(Color.black);
						g.fillRect(130+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4+1){
							g.setColor(Color.white);
							g.drawRect(130+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						}
						
						if (agent.signatureList.workMemory[selected_interaction].reference[selected_map-1][i*size*4+j*4+n*size*size*4+2].originList.size()>0) g.setColor(Color.red);
						else g.setColor(Color.black);
						g.fillRect(260+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4+2){
							g.setColor(Color.white);
							g.drawRect(260+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						}
						
						if (agent.signatureList.workMemory[selected_interaction].reference[selected_map-1][i*size*4+j*4+n*size*size*4+3].originList.size()>0) g.setColor(new Color(125,125,0));
						else g.setColor(Color.black);
						g.fillRect(390+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4+3){
							g.setColor(Color.white);
							g.drawRect(390+50+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						}
					}
				}
			}
			
			// draw paths
			g.setColor(Color.black);
			
			if (agent.signatureList.workMemory[selected_interaction].reference[selected_map-1][selected_point].originList.size()>0){
				int ref=agent.signatureList.workMemory[selected_interaction].reference[selected_map-1][selected_point].originList.get(0);
				
				for (int i=0;i<agent.signatureList.workMemory[selected_interaction].memory[ref].pathList.size();i++){
					String path="[";
					for (int l=agent.signatureList.workMemory[selected_interaction].memory[ref].pathList.get(i).length-1;l>=0;l--){
						path+=agent.signatureList.workMemory[selected_interaction].memory[ref].pathList.get(i)[l]+", ";
					}
					path+="] ; ";
					for (int l=agent.signatureList.workMemory[selected_interaction].memory[ref].originList.get(i).length-1;l>=0;l--){
						path+=agent.signatureList.workMemory[selected_interaction].memory[ref].originList.get(i)[l]+", ";
					}
					g.drawString(path, 600, 20+15*i);
				}
			}
		}
		
		

		for (int n=0;n<6;n++){
			offset=n*130;
			for (int i=0;i<size;i++){
				for (int j=0;j<size;j++){
					for (int k=0;k<3;k++){
						/*g.setColor(new Color(agent.signatureList.workMemory[selected_interaction].objectMemory[k][i*size*4+j*4+n*size*size*4+2]*100,
											 agent.signatureList.workMemory[selected_interaction].objectMemory[k][i*size*4+j*4+n*size*size*4  ]*100,
											 agent.signatureList.workMemory[selected_interaction].objectMemory[k][i*size*4+j*4+n*size*size*4+3]*100));
						g.fillRect(1000+300*k+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4+2 || selected_point==i*size*4+j*4+n*size*size*4  || selected_point==i*size*4+j*4+n*size*size*4+3){
							g.setColor(Color.white);
							g.drawRect(999+300*k+i*pixel, (140-j*pixel)+offset, pixel+2, pixel+2);
						}*/
						
						g.setColor(new Color(agent.signatureList.workMemory[selected_interaction].objectMemory[i*size*4+j*4+n*size*size*4+1]*100,
								 			 agent.signatureList.workMemory[selected_interaction].objectMemory[i*size*4+j*4+n*size*size*4+1]*100,
								 			 agent.signatureList.workMemory[selected_interaction].objectMemory[i*size*4+j*4+n*size*size*4+1]*100));
						g.fillRect(1130+300*k+i*pixel, (140-j*pixel)+offset, pixel, pixel);
						
						if (selected_point==i*size*4+j*4+n*size*size*4+1){
							g.setColor(Color.white);
							g.drawRect(1129+300*k+i*pixel, (140-j*pixel)+offset, pixel+2, pixel+2);
						}
					}
				}
			}
		}
	}
	
	
	///////////////////////////////////////////////////////////////////////////
	public void mouseClicked(MouseEvent e) {

		clic_x=e.getX();
		clic_y=e.getY();
	
		for (short j=0;j<4;j++){
			if (clic_x>=18 && clic_x<32 && clic_y>=48+20*j && clic_y<62+20*j){
				selected_interaction=j;
			}
		}
		
		for (short j=0;j<3;j++){
			if (clic_x>=18 && clic_x<32 && clic_y>=248+20*j && clic_y<262+20*j){
				selected_map=j;
				
				if (selected_map>0){
					for (int i=0;i<agent.signatureList.workMemory[selected_interaction].reference[selected_map-1][selected_point].originList.size();i++){
						System.out.print(agent.signatureList.workMemory[selected_interaction].reference[selected_map-1][selected_point].originList.get(i)+", ");
					}
					System.out.println();
				}
			}
		}
		
		int offset=0;
		for (int n=0;n<6;n++){
			offset=n*130;
			for (int i=0;i<size;i++){
				for (int j=0;j<size;j++){
					
					if (clic_x>=50+i*pixel && clic_x<50+(i+1)*pixel && clic_y>=(140-j*pixel)+offset && clic_y<(140-(j-1)*pixel)+offset){
						selected_point=i*size*4+j*4+n*size*size*4  ;
					}
					if (clic_x>=180+i*pixel && clic_x<180+(i+1)*pixel && clic_y>=(140-j*pixel)+offset && clic_y<(140-(j-1)*pixel)+offset){
						selected_point=i*size*4+j*4+n*size*size*4+1;
					}
					if (clic_x>=310+i*pixel && clic_x<310+(i+1)*pixel && clic_y>=(140-j*pixel)+offset && clic_y<(140-(j-1)*pixel)+offset){
						selected_point=i*size*4+j*4+n*size*size*4+2;
					}
					if (clic_x>=440+i*pixel && clic_x<440+(i+1)*pixel && clic_y>=(140-j*pixel)+offset && clic_y<(140-(j-1)*pixel)+offset){
						selected_point=i*size*4+j*4+n*size*size*4+3;
					}
				}
			}
		}
		
		//System.out.println("+++ "+selected_point+ " ; "+agent.signatureList.workMemory[selected_interaction].memory[selected_point].size());
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}

}