package version10_2_2_1.environment;

public class Box {

	private Environment env;
	
	private float px;								// position (x,y) in grid cell unit
	private float py;
	

	public Box(float x,float y, Environment e){
		px=x;
		py=y;
		env=e;
	}
	
	
	// move the box when pushed
	public boolean push(float d,float theta){
		
		// check if box can be moved in theta direction
		if (env.isWalkthroughable(Math.round(px+Math.cos(theta)), Math.round(py+Math.sin(theta)))
		  ||(px-Math.round(px+Math.cos(theta)))*(px-Math.round(px+Math.cos(theta)))
		   +(py-Math.round(py+Math.sin(theta)))*(py-Math.round(py+Math.sin(theta)))>0.9){
			
			px+=d*Math.cos(theta);
			py+=d*Math.sin(theta);
			
			if (env.isFood(Math.round(px), Math.round(py))) env.setBlock(Math.round(px), Math.round(py), Environment.empty);
			
			return true;
		}
		else return false;

	}
	
	// round position of the box
	public boolean center(){
		px=Math.round(px);
		py=Math.round(py);
		
		// if the box is on a tile, replace box with a prey
		boolean found=false;
		for (int i=-1;i<=1;i++){
			for (int j=-1;j<=1;j++){
				
				if (env.isTile(Math.round(px)+i,Math.round(py)+j)){
					double d=Math.sqrt( (Math.round(px)+i-px )*(Math.round(px)+i-px )
							            +(Math.round(py)+j-py )*(Math.round(py)+j-py ));
					
					// if the box is on a tile
					if (d<=0.8){
						// replace tile with a new prey
						env.setBlock(Math.round(px)+i,Math.round(py)+j,Environment.fish);
						found=true;
					}
				}
			}
		}
		return found;
	}
	
	
	///////////////////////////////////////////////////////////////////////////////
	
	public float getpx(){ return px;}
	public float getpy(){ return py;}
	
	public void setPosition(float x, float y){
		px=x;
		py=y;
	}
	
}
