package version10_2_2_1.sensorySystem;

import java.awt.Color;

import version10_2_2_1.environment.Environment;
import version10_2_2_1.platform.Agent;

public class TopView {

	private Environment m_env;
	private Agent agent;
	
	public Color[][] map;
	
	public static final int size=25;
	
	public TopView(Agent a){
		agent=a;
		map=new Color[size][size];
	}
	
	public void setEnvironment(Environment e){
		m_env=e;
	}
	
	public void probe(){
		float x=agent.body.getpx();
		float y=agent.body.getpy();
		float theta=agent.body.getrz()-(float)(Math.PI/2);
		
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++){
				
				float i2= Math.round((i-(size/2))*Math.cos(theta) - (j-(size/2))*Math.sin(theta));
				float j2= Math.round((i-(size/2))*Math.sin(theta) + (j-(size/2))*Math.cos(theta));
				
				if (x+i2>=0 && x+i2<m_env.getWidth() && y+j2>=0 && y+j2<m_env.getHeight()){
					map[i][j]=m_env.seeBlock(x+i2, y+j2);
				}
				else map[i][j]=Color.black;
			}	
		}
		
		// boxes
		for (int b=0;b<m_env.boxList.size();b++){
			
			int i=Math.round(m_env.boxList.get(b).getpx());
			int j=Math.round(m_env.boxList.get(b).getpy());
			
			int i2= (int)Math.round((i-x)*Math.cos(-theta) - (j-y)*Math.sin(-theta))+(size/2);
			int j2= (int)Math.round((i-x)*Math.sin(-theta) + (j-y)*Math.cos(-theta))+(size/2);

			if (i2>=0 && i2<size && j2>=0 && j2<size){
				map[i2][j2]=Environment.BOX;
			}
		}
		
		// agent cannot see its own position
		map[size/2][size/2]=Environment.FIELD_COLOR;
	}
	
}
